package xyz.lychee.lagfixer.libs.adventure.pointer;

import xyz.lychee.lagfixer.libs.adventure.internal.Internals;
import xyz.lychee.lagfixer.libs.adventure.key.Key;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

final class PointerImpl<T> implements Pointer<T> {
   private final Class<T> type;
   private final Key key;

   PointerImpl(final Class<T> type, final Key key) {
      this.type = type;
      this.key = key;
   }

   public @NotNull Class<T> type() {
      return this.type;
   }

   public @NotNull Key key() {
      return this.key;
   }

   public String toString() {
      return Internals.toString(this);
   }

   public boolean equals(final @Nullable Object other) {
      if (this == other) {
         return true;
      } else if (other != null && this.getClass() == other.getClass()) {
         PointerImpl<?> that = (PointerImpl)other;
         return this.type.equals(that.type) && this.key.equals(that.key);
      } else {
         return false;
      }
   }

   public int hashCode() {
      int result = this.type.hashCode();
      result = 31 * result + this.key.hashCode();
      return result;
   }
}
